// Every comment is written by Dark94 (coder of this project, aka me)

// "2- Fake Super.lua"
// A recreation of the Super Form.
// I could just use the vanilla Super Form but the way Ring Drain is handled sucks.

local GiveSuperColor = function(player, color)
	if not color
		return SKINCOLOR_SUPERGOLD1+abs(((leveltime>>1)%9)-4)
	end

	if TheEpicSuperVariantsTable[color]
		return TheEpicSuperVariantsTable[color]+abs(((leveltime>>1)%9)-4)
	else
		for i = 0, 31
			if player == players[i]
				return SKINCOLOR_CUSTOM_SUPERPLAYER0+i
			end
		end
	end
end

addHook("PlayerThink", function(player)
	if player.mo
	and player.mo.valid // We need to exist. Duh.
		if player.mo.skin == "supsonictwo" // Check we are S. S. 2
		and player.mo.health
			player.mo.color = GiveSuperColor(player, player.skincolor) // Change our color
		end
	end
end)

addHook("PlayerCanDamage", function(player) // We able to damage everything. Just like Super Sonic!
	if player.mo
	and player.mo.valid
	and player.mo.skin == "supsonictwo"
	and player.mo.health
		return true
	end
end)

addHook("MobjDamage", function(mobj, inf, src, dmg, dmgt) // Nothing can damage us! Except for stuff that instakills...
	if mobj
	and mobj.valid
	and mobj.player
	and mobj.skin == "supsonictwo"
	and mobj.health
	and dmgt != DMG_CRUSHED
	and dmgt != DMG_DEATHMASK
	and dmgt != DMG_DEATHPIT
	and dmgt != DMG_DROWNED
	and dmgt != DMG_INSTAKILL
	and dmgt != DMG_SPACEDROWN
	and dmgt != DMG_SPECTATOR
		return true // Replace the damage behavior
	end
end)