// Every comment is written by Dark94 (coder of this project, aka me)

// "1- Super colors.lua"
// Translates normal colors to their Super variants.

for i = 0, 31
	freeslot("SKINCOLOR_CUSTOM_SUPERPLAYER"..i)
	skincolors[SKINCOLOR_CUSTOM_SUPERPLAYER0+i] = {
		name = "Custom Super (Player "..i+(1)..")",
		invcolor = skincolors[SKINCOLOR_SUPERGOLD1].invcolor,
		invshade = skincolors[SKINCOLOR_SUPERGOLD1].invshade,
		accessible = false
	}
end


for i = 1, #skincolors-1
	skincolors[i].accessible = true
end

rawset(_G, "TheEpicSuperVariantsTable", {})
TheEpicSuperVariantsTable = { // Some colors and their Super variants
	// Super Silver
	[SKINCOLOR_WHITE] = SKINCOLOR_SUPERSILVER1,
	[SKINCOLOR_BONE] = SKINCOLOR_SUPERSILVER1,
	[SKINCOLOR_CLOUDY] = SKINCOLOR_SUPERSILVER1,
	[SKINCOLOR_SILVER] = SKINCOLOR_SUPERSILVER1,
	// Super Red
	[SKINCOLOR_PEPPER] = SKINCOLOR_SUPERRED1,
	[SKINCOLOR_RED] = SKINCOLOR_SUPERRED1,
	[SKINCOLOR_CRIMSON] = SKINCOLOR_SUPERRED1,
	// Super Orange
	[SKINCOLOR_COPPER] = SKINCOLOR_SUPERORANGE1,
	[SKINCOLOR_ORANGE] = SKINCOLOR_SUPERORANGE1,
	[SKINCOLOR_TANGERINE] = SKINCOLOR_SUPERORANGE1
}

local RampFramesThingie = { // "w" means white
	[0] = {"w", "w", "w", "w", "w", "w", "w", "w", "w", "w", 0, 0, 0, 1, 1, 1},
	[1] = {"w", "w", "w", "w", 0, 0, 1, 1, 2, 2, 3, 3, 4, 5, 6, 9},
	[2] = {"w", 0, 0, 0, 1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11},
	[3] = {0, 0, 1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13},
	[4] = "normalcolor"
}

local customsupervariantscount = 0

addHook("ThinkFrame", function()
	// Absolute chaos
	for plyrs = 0, 31
		for i = 1, #skincolors-1
			if not TheEpicSuperVariantsTable[i]
			and players[plyrs]
			and players[plyrs].skincolor == i
				local weirdmath = abs(((leveltime>>1)%9)-4)

				for j = 1, #RampFramesThingie[weirdmath]-1
					local the_color
					if RampFramesThingie[weirdmath][j] == "w"
						the_color = 0
					elseif RampFramesThingie[weirdmath] == "normalcolor"
						the_color = skincolors[i].ramp[j]
					else
						the_color = skincolors[i].ramp[RampFramesThingie[weirdmath][j]]
					end

					for k = 0, 31
						skincolors[SKINCOLOR_CUSTOM_SUPERPLAYER0+plyrs].ramp[j] = the_color
					end
				end
			end
		end
	end
end)